function saveData(level, liked, numAds, musicON, volumeFXs, tutorial) {
    localStorage.setItem("savedData", JSON.stringify({
        "level": level,
        "tutorial": tutorial,
        "liked": liked,
        "watchedAd": numAds,
        "musicON": musicON,
        "volumeFXs": volumeFXs
    }));
}

function saveHelpHint(value) {
    localStorage.setItem("helpHint", JSON.stringify({
        "hintOn": value
    }));
}

function resetHintTimer(startAgain) {
    if (GAMEMODE.helpTipTimer) {
        clearTimeout(GAMEMODE.helpTipTimer);
        GAMEMODE.helpTipTimer = null;
    }

    if (GAMEMODE.helpTip && startAgain) {
        GAMEMODE.helpTipTimer = setTimeout(showHintHelper, parseInt(GAMEMODE.timerSeconds));
    }
}

function showHintHelper() {
    function noHandler() {
        resetHintTimer(true);
    }
    function yesHandler() {
        if (GAMEMODE.pointerToLevel.soundPopUp.shown) {
            GAMEMODE.pointerToLevel.soundPopUp.hidePopUp();
        }
        GAMEMODE.pointerToLevel.helpPopUp.setUp();

        resetHintTimer(true);
    }
    function turnOffHandler() {
        GAMEMODE.helpTip = false;
        saveHelpHint(false);
        resetHintTimer(false);
    }

    function onConfirm(buttonPressed) {
        if (buttonPressed === 1) {
            yesHandler();
        }

        else if (buttonPressed === 2) {
            noHandler();
        }

        else if (buttonPressed === 3) {
            turnOffHandler();
        }
        else {
            resetHintTimer(true);
        }
    }

    if (!GAMEMODE.pointerToLevel.helpPopUp.shown) {
        navigator.notification.confirm(
            "You've been here for a while. Do you need help?", // message
            onConfirm, // callback to invoke with index of button pressed
            "Help", // title
             ["Yes", "No", "Turn off this"] // buttonLabels
        );
    }
    else {
        resetHintTimer(true);
    }
}

function addWatchedAd(infoObject) {
    var serverAddress = "http://nestats.azurewebsites.net/";
    GAMEMODE.watchedAd++;

    saveData(GAMEMODE.openedLevels, GAMEMODE.likedFB, GAMEMODE.watchedAd, MUSICMANAGER.musicON, MUSICMANAGER.volumeFXs, GAMEMODE.tutorial);

    var objForSend = {
        key: "someRandomString",
        type: ADSMANAGER.type,
        level: GAMEMODE.levelNumber,
        time: game.time.totalElapsedSeconds(),
        moreInfo: JSON.stringify(infoObject)
    }
    //send info to the server
    sendStatistics(serverAddress, objForSend, "postStatisticsForWalkthroughs")
}

function sendStatistics(address, objForSending, query) {
    var serverAddress = address;
    function failedRequest() {
    }
    $.ajax({
        type: "POST",
        data: objForSending,
        url: serverAddress + query,
        dataType: 'JSON',
        tryCount: 0,
        retryLimit: 5
    }).done(function (response) { console.log(response.error); }).fail(failedRequest);

}

function fileComplete(progress, cacheKey, success, totalLoaded, totalFiles) {
    //17, zashtoto ima 6 syrca v loading screen- a
    if (progress > this.atLoading * 17) {
        this.loadingHearts[this.atLoading - 1].visible = true;
        this.atLoading++;
    }
}

function loadComplete() {
    this.loadBck.destroy();
    for (var i = 0; i < 6; i++)
        this.loadingHearts[i].destroy();
}

function findNumber(x, y) {
    if (x > 281 && x < 393 && y > 276 && y < 386)
        return 1;
    if (x >= 393 && x < 506 && y > 276 && y < 386)
        return 2;
    if (x >= 506 && x < 619 && y > 276 && y < 386)
        return 3;
    if (x > 281 && x < 393 && y >= 386 && y < 496)
        return 4;
    if (x >= 393 && x < 506 && y >= 386 && y < 496)
        return 5;
    if (x >= 506 && x < 619 && y >= 386 && y < 496)
        return 6;
    if (x > 281 && x < 393 && y >= 496 && y < 606)
        return 7;
    if (x >= 393 && x < 506 && y >= 496 && y < 606)
        return 8;
    if (x >= 506 && x < 619 && y >= 496 && y < 606)
        return 9;
    //enter
    if (x > 281 && x < 393 && y > 606 && y < 716)
        return 12;
    if (x >= 393 && x < 506 && y >= 606 && y < 716)
        return 0;
    //clear
    if (x > 506 && x < 619 && y > 606 && y < 716)
        return 11;

    //ako ne nameri nishto vryshta kod za greshka
    return 10;
}

function addActor(game, x, y, img, width, height, id, inputEnabled, handler, objForHandler, visible) {
    retV = game.add.sprite(x, y, img);
    retV.width = width;
    retV.height = height;
    retV.id = id;
    if (inputEnabled) {
        retV.inputEnabled = inputEnabled;
        retV.events.onInputUp.add(handler, objForHandler);
    }
    retV.visible = visible;

    return retV;
}

function setSizeActor(actor, width, height) {
    actor.width = width;
    actor.height = height;
}
function setUpALevel(game) {
    game.world.setBounds(0, 0, 2048, 768);
    //adds background
    game.backGroundRoom = game.add.sprite(0, 0, "background");
    //adds kolelce za dvijenie na kamerata
    game.kolelce = game.add.sprite(256, 668, "kolelce");
    game.kolelce.fixedToCamera = true;
    //adds BackToMenuButton and MuteButton
    game.backToMenu = game.add.button(0, 0, "backToMenuBtn", function () {
        game.state.start("mainMenu");
    }, this, 0, 0, 1);
    game.backToMenu.fixedToCamera = true;
    //adds sound button
    game.soundPopUp = {
        shown: false,
        items: [],
        setUp: function () {
            this.items.push(game.add.sprite(320, 256, "messbox"));
            this.items[0].fixedToCamera = true;
            this.items[0].inputEnabled = true;

            this.items.push(addActor(game, 635, 321, "tikcheta", 50, 50, 901, true, function (e) {
                if (MUSICMANAGER.musicON) {
                    MUSICMANAGER.musicON = !MUSICMANAGER.musicON;
                    e.frame = 0;
                    stopMusic();
                }
                else {
                    MUSICMANAGER.musicON = !MUSICMANAGER.musicON;
                    e.frame = 1;
                    startMusic();
                }
            }, game, true));
            this.items[1].frame = MUSICMANAGER.musicON ? 1 : 0;
            this.items[1].fixedToCamera = true;

            this.items.push(addActor(game, 635, 403, "tikcheta", 50, 50, 902, true, function (e) {
                if (MUSICMANAGER.volumeFXs === 1) {
                    MUSICMANAGER.volumeFXs = 0;
                    e.frame = 0;
                    stopFXs();
                }
                else {
                    MUSICMANAGER.volumeFXs = 1;
                    e.frame = 1;
                    startFXs();
                }
            }, game, true));
            this.items[2].frame = MUSICMANAGER.volumeFXs === 1 ? 1 : 0;
            this.items[2].fixedToCamera = true;

            this.items.push(addActor(game, 648, 256, "closeBtn", 48, 48, 903, true, function () {
                this.soundPopUp.hidePopUp();
            }, game, true));
            this.items[3].fixedToCamera = true;
            this.shown = true;
        },
        hidePopUp: function () {
            for (var i = 0; i < this.items.length; i++) {
                this.items[i].destroy();
                this.items[i] = null;
            }
            this.items = null;
            this.items = [];
            this.shown = false;
        }
    };

    game.soundBtn = game.add.button(100, 0, "soundBtn", function () {
        if (!game.soundPopUp.shown) {
            if (game.helpPopUp.shown) {
                game.helpPopUp.hidePopUp();
            }
            game.soundPopUp.setUp();
        }
        else {
            game.soundPopUp.hidePopUp();
        }
    }, game, 0, 0, 1);
    game.soundBtn.fixedToCamera = true;
    //adds helpBtn
    game.helpPopUp = {
        shown: false,
        items: [],
        setUp: function () {
            this.items.push(addActor(game, 262, 217, "helpBox", 500, 334, 901, true, function () { }, {}, true));
            this.items[0].fixedToCamera = true;

            this.items.push(game.add.button(356, 320, "textWalkBtn", function (e) {
                helpButton("text");
            }, this, 0, 0, 1));
            this.items[1].fixedToCamera = true;

            this.items.push(game.add.button(356, 426, "videoWalkBtn", function (e) {
                helpButton("video");
            }, this, 0, 0, 1));
            this.items[2].fixedToCamera = true;

            this.items.push(addActor(game, 688, 217, "closeBtn", 60, 60, 903, true, function () {
                this.helpPopUp.hidePopUp();
            }, game, true));
            this.items[3].fixedToCamera = true;
            this.shown = true;
        },
        hidePopUp: function () {
            for (var i = 0; i < this.items.length; i++) {
                this.items[i].destroy();
                this.items[i] = null;
            }
            this.items = null;
            this.items = [];
            this.shown = false;
        }
    };
    game.helpBtn = game.add.button(200, 0, "helpBtn", function () { //924 28
        if (!game.helpPopUp.shown) {
            if (game.soundPopUp.shown) {
                game.soundPopUp.hidePopUp();
            }
            game.helpPopUp.setUp();
        }
        else {
            game.helpPopUp.hidePopUp();
        }
    }, this, 0, 0, 1);
    game.helpBtn.fixedToCamera = true;
    //adds FBLike Btn
    game.fbBtn = game.add.button(310, 20, "fbBtn", function () { //924 28
        window.open(GAMEMODE.fbLinkToPage, '_system');
    }, this, 0, 0, 1);
    game.fbBtn.fixedToCamera = true;
    game.menuButtons = [game.backToMenu, game.helpBtn, game.fbBtn];

    //adds camera info and moving
    game.cameraMan = game.add.sprite(512, game.world.centerY, "camera");
    game.cameraXBeforeSmallScene = game.cameraMan.x;
    game.camera.follow(game.cameraMan);
    game.kolelce.lastMoved = 0;
    game.kolelce.inputEnabled = true;
    game.kolelce.events.onInputDown.add(function () {
        game.cameraMove = true;
        game.oldMouseX = game.input.x;
        game.kolelce.lastMoved = game.input.x;
    }, game);
    game.kolelce.events.onInputUp.add(function () {
        game.cameraMove = false;
    }, game);
    //adds HUD
    if (GAMEMODE.levelNumber === 5) {
        game.HUD = game.add.sprite(902, 27, "hud_big");
    }
    else {
        game.HUD = game.add.sprite(902, 126, "HUD");
    }
    game.HUD.fixedToCamera = true;
    game.HUD.inputEnabled = true;

    //adds smallcene manager
    game.smallScene = game.add.sprite(0, 0, "smallscenes0");
    game.smallScene.id = -1;
    game.smallScene.width = 0;
    game.smallScene.height = 0;
    game.smallScene.shown = false;
    game.smallScene.inputEnabled = true;

    game.bringMenuButtonsToTop = function () {
        game.menuButtons.forEach(function (member) {
            member.bringToTop();
        });
    };
}

function bringTopMenuToTop(game) {
    game.backToMenu.bringToTop();
    game.soundBtn.bringToTop();
    game.helpBtn.bringToTop();
    game.fbBtn.bringToTop();
}

function makeHUDItems(game) {
    game.hudItems = [];
    if (GAMEMODE.levelNumber === 5) {
        game.hudItems.push(game.add.sprite(915, 132, "emptyItem"));
        game.hudItems.push(game.add.sprite(915, 233, "emptyItem"));
        game.hudItems.push(game.add.sprite(915, 334, "emptyItem"));
        game.hudItems.push(game.add.sprite(915, 435, "emptyItem"));
        game.hudItems.push(game.add.sprite(915, 536, "emptyItem"));
        game.hudItems.push(game.add.sprite(915, 637, "emptyItem"));
    }
    else {
        game.hudItems.push(game.add.sprite(914, 231, "emptyItem"));
        game.hudItems.push(game.add.sprite(914, 332, "emptyItem"));
        game.hudItems.push(game.add.sprite(914, 433, "emptyItem"));
        game.hudItems.push(game.add.sprite(914, 534, "emptyItem"));
    }
    game.selector = game.add.sprite(914, 0, "selector");
    game.selector.visible = false;
    game.selector.fixedToCamera = true;
    for (var i = 0; i < game.hudItems.length; i++) {
        game.hudItems[i].fixedToCamera = true;
        game.hudItems[i].inputEnabled = true;
        game.hudItems[i].events.onInputDown.add(handleHUDItems, { event: game });
        game.hudItems[i].visible = false;
        game.hudItems[i].id = null;
    }

}

function handleHUDItems(e) {
    if (this.event.itemSelected === null) {
        this.event.selector.x = 915;
        this.event.selector.y = e.y;
        this.event.selector.visible = true;
        this.event.selector.fixedToCamera = true;
        this.event.itemSelected = e;
    }
    else {
        if (!canTheyCombine(this.event.itemSelected, e, this.event)) {
            this.event.selector.visible = false;
            this.event.itemSelected = null;
        }
    }
}

function takeItem(e) {
    var taken = false;
    for (var i = 0; i < this.game.hudItems.length; i++) {
        if (!taken && this.game.hudItems[i].id === null) {
            taken = true;
            this.game.hudItems[i].id = e.id;
            this.game.hudItems[i].loadTexture(e.id);
            this.game.hudItems[i].visible = true;
            e.taken = true;
            e.kill();
        }
    }
    return taken;
}

function addTakableItem(actor) {
    actor.taken = false;
    return actor;
}

function removeItemFromHUD(game) {
    game.selector.visible = false;
    game.itemSelected.visible = false;
    game.itemSelected.id = null;
    game.itemSelected = null;
}

function canTheyCombine(e1, e2, game) {
    var combinations = [["203 204", 205], ["105 106", 107], ["304 306", 308], ["301 302", 312],
        ["407 408", 409], ["404 411", 415], ["414 415", 412],
        ["505 512", 515], ["510 516", 517]];
    for (var i = 0; i < combinations.length; i++) {
        if ((e1.id + " " + e2.id) === combinations[i][0] || (e2.id + " " + e1.id) === combinations[i][0]) {
            game.selector.visible = false;
            game.itemSelected.visible = false;
            game.itemSelected.id = null;
            game.itemSelected = null;
            e2.id = combinations[i][1];
            e2.loadTexture(e2.id);
            return true;
        }
    }
    return false;
}

function takeItemIndirectly(e, game) {
    var taken = false;
    for (var i = 0; i < game.hudItems.length; i++) {
        if (!taken && game.hudItems[i].id === null) {
            taken = true;
            game.hudItems[i].id = e.id;
            game.hudItems[i].loadTexture(e.id);
            game.hudItems[i].visible = true;
            e.taken = true;
            e.kill();
        }
    }
}

function helpButton(type) {
    var networkState = navigator.connection.type;
    if (networkState === Connection.NONE) {
        alert("You have to be connected to the internet to be able to see the walkthroughs.")
    }
    else {
        ADSMANAGER.type = type;
        if (ADSMANAGER.ready) {
            var objForSending = makeObjectForSending();
            addWatchedAd(objForSending);
            playAd();
        }
        else {
            endAd();
        }
    }
}

function makeObjectForSending() {
    switch (GAMEMODE.levelNumber) {
        case 1: {
            return {
                vaseUnlocked: GAMEMODE.pointerToLevel.vaseUnlocked,
                doorOnline: GAMEMODE.pointerToLevel.doorOnline
            };
            break;
        }
        case 2: {
            return {
                logicGameCompleted: GAMEMODE.pointerToLevel.logicGame.done
            };
            break;
        }
        case 3: {
            return {
                btnGameFinished: GAMEMODE.pointerToLevel.btnGameFinished
            };
            break;
        }
        case 4: {
            return {
            };
            break;
        }
        case 5: {
            return {
            };
            break;
        }
    }
    return {};
}



//-------------------------------------------- Video Handlers --------------------------------
function downLoadFile(name, callback) {
    //imeto
    var myFilename = name;
    //otkyde da go zeme localno
    var myUrl = cordova.file.applicationDirectory + "www/assets/videos/" + myFilename;
    //puska file transfer
    var fileTransfer = new FileTransfer();
    //tochno kyde da go prati videoto
    var filePath = cordova.file.dataDirectory + myFilename;
    //puska smqnata, koeto e se edno download
    fileTransfer.download(encodeURI(myUrl), filePath, (function (entry) {
        callback(entry);
    }), (function (error) {
    }), true, {
        headers: {
            Authorization: "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
        }
    });
}

function playPlayer(video) {
    VideoPlayer.play(video.entry.nativeURL,
    {
        volume: MUSICMANAGER.volumeFXs,
        scalingMode: VideoPlayer.SCALING_MODE.SCALE_TO_FIT_WITH_CROPPING
    },
    function () {
        if (MUSICMANAGER.musicON) {
            resumeMusicForVideo();
        }
        GAMEMODE.pointerToLevel.videoPlaying = false;
    },
    function (err) {
        if (MUSICMANAGER.musicON) {
            resumeMusicForVideo();
        }
        GAMEMODE.pointerToLevel.videoPlaying = false;
    }
    );
}

function Video(name, startID, endID, entry, callback, level) {
    this.name = name;
    this.startID = startID;
    this.endID = endID;
    this.entry = entry;
    //da sloja proverka dali e funkciq
    this.callback = callback;
    this.level = level;
    this.shown = false;
    return this;
}

function setUpVideos() {
    //check if the videos are in the right folder by retrieving the list of entries and check if it's correct
    //if the list is null or undefined copy them if there is a list check file by file and copy the ones that are not correct.
    //if they are setUp videos from the list that is going to be loaded
    var videoEntries = loadVideosEntries();
    if (!videoEntries) {
        //kopirai si4ki videota
        copyVideosToFolder();
    }
    else {
        checkVideo(videoEntries);
    }
}

function copyVideosToFolder() {
    var videoEntries = [];
    function onLoadCallback(entry) {
        videoEntries.push(entry);
        if (GAMEMODE.videoNames.length === videoEntries.length) {
            saveVideos(videoEntries);
            constructVideos(videoEntries);
        }
    }
    for (var i = 0; i < GAMEMODE.videoNames.length; i++) {
        downLoadFile(GAMEMODE.videoNames[i] + ".mp4", onLoadCallback);
    }
}

function saveVideos(listOfEntries) {
    var arrayToSave = [];
    for (var i = 0; i < listOfEntries.length; i++)
        arrayToSave.push(JSON.stringify(listOfEntries[i]));

    localStorage.setItem("videoEntries", JSON.stringify(arrayToSave));
}

function loadVideosEntries() {
    var listOfStringifiedEntries = JSON.parse(localStorage.getItem("videoEntries"));
    if (listOfStringifiedEntries) {
        var returnList = [];
        for (var i = 0; i < listOfStringifiedEntries.length; i++)
            returnList.push(JSON.parse(listOfStringifiedEntries[i]));
        return returnList;
    }
    else {
        return null;
    }
}

function checkVideo(listOfEntries) {
    //proveri vsqko video dali si e na mqstoto i vyrni list koito sydyrja vsi4ki verni pri gre6ka
    //da proverq dali .isFile raboti
    var buggedFiles = false;
    for (var i = 0; i < listOfEntries.length; i++) {
        if (!listOfEntries[i].isFile) {
            buggedFiles = true;
        }
    }
    if (!buggedFiles)
        constructVideos(listOfEntries);
    else {
        localStorage.removeItem("videoEntries");
        copyVideosToFolder();
    }
}

function constructVideos(listOfEntries) {
    //tuk da gi opravq zashtoto reda ne e siguren kakaf 6te e na kopirane da izpolzvam .name, za da razbera
    var videos = {};
    for (var i = 0; i < listOfEntries.length; i++) {
        var nameToUse = listOfEntries[i].name.split(".");
        //izpolzva se nameToUse[0], zashtoto tova e imeto na faila bez poslednata mu 4ast, kqoto e sy6tnost tipa na faila
        switch (nameToUse[0]) {
            case GAMEMODE.videoNames[0]: {
                //video normalno do shkaf
                videos[GAMEMODE.videoNames[0]] = new Video(GAMEMODE.videoNames[0], 1, 2, listOfEntries[i], function () {
                    //smenq izgleda na scenata
                    GAMEMODE.pointerToLevel.smallScene.frame = game.videos[GAMEMODE.videoNames[0]].endID - 1;
                    GAMEMODE.pointerToLevel.smallScene.id = game.videos[GAMEMODE.videoNames[0]].endID;

                    //smenq ID- to na itema, koito go e viknal, za da moje sledvashtiq pyt videoto da ne se puska, kato i izprazva steka s itemite koito sa bili pokazvani togava
                    GAMEMODE.pointerToLevel.rightShelf.id = game.videos[GAMEMODE.videoNames[0]].endID;
                    GAMEMODE.pointerToLevel.popListToHide();

                    //pokazva novite itemi i gi vkarva v steka, za da znae posle back butona ko da prai
                    GAMEMODE.pointerToLevel.fotka.visible = true;
                    GAMEMODE.pointerToLevel.knife.visible = true;

                    GAMEMODE.pointerToLevel.itemsToHide.push([GAMEMODE.pointerToLevel.fotka, GAMEMODE.pointerToLevel.knife]);
                }, 1);
                break;
            }
            case GAMEMODE.videoNames[1]: {
                //video do shkaf po- bavno
                videos[GAMEMODE.videoNames[1]] = new Video(GAMEMODE.videoNames[1], 4, 5, listOfEntries[i], function () {
                    //smenq izgleda na scenata
                    GAMEMODE.pointerToLevel.smallScene.frame = game.videos[GAMEMODE.videoNames[1]].endID - 1;
                    GAMEMODE.pointerToLevel.smallScene.id = game.videos[GAMEMODE.videoNames[1]].endID;

                    //smenq ID- to na itema, koito go e viknal, za da moje sledvashtiq pyt videoto da ne se puska, kato i izprazva steka s itemite koito sa bili pokazvani togava
                    GAMEMODE.pointerToLevel.leftShelf.id = game.videos[GAMEMODE.videoNames[1]].endID;
                    GAMEMODE.pointerToLevel.popListToHide();

                    //pokazva novite itemi i gi vkarva v steka, za da znae posle back butona ko da prai
                    GAMEMODE.pointerToLevel.dupkaBushon.visible = true;

                    GAMEMODE.pointerToLevel.itemsToHide.push([GAMEMODE.pointerToLevel.dupkaBushon]);
                }, 1);
                break;
            }
            case GAMEMODE.videoNames[2]: {
                //video s smqna pod shkaf
                videos[GAMEMODE.videoNames[2]] = new Video(GAMEMODE.videoNames[2], 5, 6, listOfEntries[i], function () {
                    //smenq izgleda na scenata
                    GAMEMODE.pointerToLevel.smallScene.frame = game.videos[GAMEMODE.videoNames[2]].endID - 1;
                    GAMEMODE.pointerToLevel.smallScene.id = game.videos[GAMEMODE.videoNames[2]].endID;

                    //smenq ID- to na itema, koito go e viknal, za da moje sledvashtiq pyt videoto da ne se puska, kato i izprazva steka s itemite koito sa bili pokazvani togava
                    GAMEMODE.pointerToLevel.leftShelf.id = game.videos[GAMEMODE.videoNames[2]].endID;
                    GAMEMODE.pointerToLevel.popListToHide();

                    //pokazva novite itemi i gi vkarva v steka, za da znae  posle back butona ko da prai
                    GAMEMODE.pointerToLevel.dupkaBushon.destroy();
                    GAMEMODE.pointerToLevel.listche.visible = true;

                    GAMEMODE.pointerToLevel.itemsToHide.push([GAMEMODE.pointerToLevel.listche]);
                }, 1);
                break;
            }
            case GAMEMODE.videoNames[3]: {
                //video s fener
                videos[GAMEMODE.videoNames[3]] = new Video(GAMEMODE.videoNames[3], 1, 1, listOfEntries[i], function () {
                    takeItem.apply({ game: GAMEMODE.pointerToLevel }, [GAMEMODE.pointerToLevel.light]);
                }, 2);
                break;
            }
            case GAMEMODE.videoNames[4]: {
                //video s izkachashti klouni
                videos[GAMEMODE.videoNames[4]] = new Video(GAMEMODE.videoNames[4], 1, 9, listOfEntries[i], function () {
                    GAMEMODE.pointerToLevel.handleSmallScenes.apply({
                        event: GAMEMODE.pointerToLevel,
                        scene: GAMEMODE.pointerToLevel.smallScene,
                        visibilityAndActionHandler: function (game) {
                            game.popListToHide();
                        }
                    }, [{ id: 9 }]);
                    GAMEMODE.pointerToLevel.masaSredna.id = 9;
                }, 2);
                break;
            }
            case GAMEMODE.videoNames[5]: {
                //video s koridora
                videos[GAMEMODE.videoNames[5]] = new Video(GAMEMODE.videoNames[5], 1, 1, listOfEntries[i], function () {
                    if (GAMEMODE.openedLevels === 2) {
                        GAMEMODE.openedLevels = 3;
                        saveData(GAMEMODE.openedLevels, GAMEMODE.likedFB, GAMEMODE.watchedAd, MUSICMANAGER.musicON, MUSICMANAGER.volumeFXs, GAMEMODE.tutorial);
                    }
                    GAMEMODE.pointerToLevel.state.start("Level3");
                }, 3);
                break;
            }
            case GAMEMODE.videoNames[6]: {
                //video s alarma
                videos[GAMEMODE.videoNames[6]] = new Video(GAMEMODE.videoNames[6], 1, 1, listOfEntries[i], function () {
                    GAMEMODE.pointerToLevel.vaseItem.frame = 0;
                    GAMEMODE.pointerToLevel.vaseItem.id = 101;
                    GAMEMODE.pointerToLevel.backBtn.visible = true;
                    GAMEMODE.pointerToLevel.videoManager[GAMEMODE.videoNames[6]] = false;
                }, 4);
                break;
            }
            case GAMEMODE.videoNames[7]: {
                //video s dialog
                videos[GAMEMODE.videoNames[7]] = new Video(GAMEMODE.videoNames[7], 1, 3, listOfEntries[i], function () {
                    GAMEMODE.pointerToLevel.changeSmallScenes.apply({
                        event: GAMEMODE.pointerToLevel,
                        scene: GAMEMODE.pointerToLevel.smallScene,
                        visibilityHandlerShow: function (game) {
                            game.shkafIgrachki.visible = true;
                            if (!game.kolba.taken) {
                                game.kolba.visible = true;
                            }
                            if (!game.dyska.taken) {
                                game.dyska.visible = true;
                            }
                        },
                        getListToHide: function (game) {
                            var returnV = [];

                            returnV.push(game.shkafIgrachki);
                            if (!game.kolba.taken) {
                                returnV.push(game.kolba);
                            }

                            if (!game.dyska.taken) {
                                returnV.push(game.dyska);
                            }

                            return returnV;
                        }
                    }, [GAMEMODE.pointerToLevel.legloShkaf]);
                }, 4);
                break;
            }
            case GAMEMODE.videoNames[8]: {
                //video s monolog
                videos[GAMEMODE.videoNames[8]] = new Video(GAMEMODE.videoNames[8], 3, 8, listOfEntries[i], function () {
                    GAMEMODE.pointerToLevel.handleSmallScenes.apply({
                        event: GAMEMODE.pointerToLevel,
                        scene: GAMEMODE.pointerToLevel.smallScene,
                        visibilityAndActionHandler: function (game) {
                            game.popListToHide();
                            var itemsToHide = [];
                            //include files that are going to be visible on the next scene
                            if (!game.prysten.taken) {
                                game.prysten.visible = true;
                                itemsToHide.push(game.prysten);
                            }
                            game.listNaShkaf.visible = true;
                            itemsToHide.push(game.listNaShkaf);

                            game.itemsToHide.push(itemsToHide);
                        }
                    }, [GAMEMODE.pointerToLevel.shkafIgrachki]);
                }, 4);
                break;
            }
            case GAMEMODE.videoNames[9]: {
                //final video
                videos[GAMEMODE.videoNames[9]] = new Video(GAMEMODE.videoNames[9], 1, 1, listOfEntries[i], function () {
                    GAMEMODE.pointerToLevel.state.start("finalScreen");
                }, 5);
                break;
            }
        }
    }
    game.videos = videos;
    setTimeout(function () {
        game.state.start("boot");
    }, 500);
}

//-------------------------------------------------------iOS-----------------------------------------------------
function setUpiOSVideos() {
    var listOfEntries = ["videoUno.mp4", "videoDos.mp4", "videoTres.mp4", "videoQuatro.mp4", "videoSinco.mp4", "videoSeis.mp4", "videoSiete.mp4", "videoOcho.mp4", "videoNueve.mp4", "videoDiez.mp4"];
    constructVideos(listOfEntries);
}

function playiOSVideo(name) {
    var videoUrl = cordova.file.applicationDirectory + "www/assets/videos/" + name + ".mp4";

    // Play a video with callbacks
    var options = {
        successCallback: function () {
            if (MUSICMANAGER.musicON) {
                resumeMusicForVideo();
            }
            GAMEMODE.pointerToLevel.videoPlaying = false;
        },
        errorCallback: function (errMsg) {
            if (MUSICMANAGER.musicON) {
                resumeMusicForVideo();
            }
            GAMEMODE.pointerToLevel.videoPlaying = false;
        },
        orientation: 'landscape'
    };
    window.plugins.streamingMedia.playVideo(videoUrl, options);
}

//----------------------------------------------------------AUDIO-------------------------------------------------
function setUpAudioFiles() {
    MUSICMANAGER.musicLevelBackground = new Media(cordova.file.applicationDirectory + "www/assets/Audio/mainBackGroundAudio.mp3", function () {
    },
    function (err) {
    },
    function (status) {
        if (status === 4 && !GAMEMODE.gameClosing && MUSICMANAGER.volumeFXs) {
            MUSICMANAGER.musicLevelBackground.play();
        }
    });

    MUSICMANAGER.laugh_1 = new Media(cordova.file.applicationDirectory + "www/assets/Audio/laugh_1.mp3", function () { },
    function (err) {
        MUSICMANAGER.laugh_1 = null;
    });

    MUSICMANAGER.laugh_2 = new Media(cordova.file.applicationDirectory + "www/assets/Audio/laugh_2.mp3", function () { },
        function (err) {
            MUSICMANAGER.laugh_2 = null;
        });

    MUSICMANAGER.laugh_3 = new Media(cordova.file.applicationDirectory + "www/assets/Audio/laugh_3.mp3", function () { },
    function (err) {
        MUSICMANAGER.laugh_3 = null;
    });

    MUSICMANAGER.trapSnap = new Media(cordova.file.applicationDirectory + "www/assets/Audio/snap.mp3", function () { },
        function (err) {
            MUSICMANAGER.trapSnap = null;
        });

    if (MUSICMANAGER.volumeFXs > 0) {
        MUSICMANAGER.musicLevelBackground.play();
    }
    MUSICMANAGER.musicPlayingAtTheMoment.push(MUSICMANAGER.musicLevelBackground);

    MUSICMANAGER.atB = getRandomIntInclusive(0, 4);

    if (MUSICMANAGER.musicON) {
        MUSICMANAGER.nextSongCallback = setTimeout(playRandomBox, 3000);
    }
}

function playRandomBox() {
    MUSICMANAGER.nextSongCallback = null;
    if (MUSICMANAGER.musicON && !MUSICMANAGER.song) {
        MUSICMANAGER.atB = (MUSICMANAGER.atB + 1) % 5;
        MUSICMANAGER.song = new Media(cordova.file.applicationDirectory + "www/assets/Audio/b_" + MUSICMANAGER.atB + ".mp3", function () { },
    function (err) {
        if (!GAMEMODE.gameClosing) {
            if (MUSICMANAGER.song) {
                MUSICMANAGER.song.release();
                MUSICMANAGER.song = null;
            }
            MUSICMANAGER.nextSongCallback = setTimeout(playRandomBox, 11000);
        }
    }, function (status) {
        if (status === 4 && !GAMEMODE.gameClosing) {
            MUSICMANAGER.song.release();
            MUSICMANAGER.song = null;
            MUSICMANAGER.nextSongCallback = setTimeout(playRandomBox, 11000);
        }
    });
        if (!GAMEMODE.pointerToLevel.videoPlaying) {
            MUSICMANAGER.song.play();
        }
    }
}

function pauseMusicForVideo() {
    for (var i = 0; i < MUSICMANAGER.musicPlayingAtTheMoment.length; i++) {
        MUSICMANAGER.musicPlayingAtTheMoment[i].pause();
    }
    if (MUSICMANAGER.song) {
        var volume = 1;
        var effectFadeOut = setInterval(function () {
            volume -= 0.1;
            MUSICMANAGER.song.setVolume(volume);

            if (volume <= 0) {
                MUSICMANAGER.song.pause();
                clearInterval(effectFadeOut);
            }
        }, 110);
    }
}

function resumeMusicForVideo() {
    for (var i = 0; i < MUSICMANAGER.musicPlayingAtTheMoment.length; i++) {
        MUSICMANAGER.musicPlayingAtTheMoment[i].play();
    }
    if (MUSICMANAGER.song) {
        MUSICMANAGER.song.setVolume(1);
        MUSICMANAGER.song.play();
    }
}

function stopMusic() {
    if (MUSICMANAGER.song) {
        MUSICMANAGER.song.stop();
        MUSICMANAGER.song.release();
        MUSICMANAGER.song = null;
    }
    else if (MUSICMANAGER.nextSongCallback) {
        clearInterval(MUSICMANAGER.nextSongCallback);
    }
}

function startMusic() {
    playRandomBox();
}

function stopFXs() {
    if (MUSICMANAGER.musicLevelBackground) {
        //if there are more items it should pop all the items
        MUSICMANAGER.musicPlayingAtTheMoment.pop();
        MUSICMANAGER.musicLevelBackground.stop();
    }
}

function startFXs() {
    if (MUSICMANAGER.musicLevelBackground) {
        MUSICMANAGER.musicPlayingAtTheMoment.push(MUSICMANAGER.musicLevelBackground);
        MUSICMANAGER.musicLevelBackground.play();
    }
}

//--------------------------------------------------------OTHER------------------------------------------------------
function getRandomIntInclusive(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

//--------------------------------------------------------MEMORY CLEAR-----------------------------------------------
function quitGame() {

    GAMEMODE.gameClosing = true;
    saveData(GAMEMODE.openedLevels, GAMEMODE.likedFB, GAMEMODE.watchedAd, MUSICMANAGER.musicON, MUSICMANAGER.volumeFXs, GAMEMODE.tutorial);

    //clears the music and FXs playing
    for (var i = 0; i < MUSICMANAGER.musicPlayingAtTheMoment.length; i++) {
        MUSICMANAGER.musicPlayingAtTheMoment[i].stop();
        MUSICMANAGER.musicPlayingAtTheMoment[i].release();
    }
    if (MUSICMANAGER.song) {
        MUSICMANAGER.song.stop();
        MUSICMANAGER.song.release();
    }

    //clears all timeouts
    var maxId = setTimeout(function () { }, 0);

    for (var i = 0; i < maxId; i += 1) {
        clearTimeout(i);
    }

    setTimeout(function () {
        navigator.app.exitApp();
    }, 0);
}