var boot = function (game) {
};

boot.prototype = {

    preload: function () {
        this.load.image("loading", "assets/loadProgress.png");
        this.load.image("loadingBackground", "assets/loading.png");
        //this.load.audio('music', ['assets/audio/bckrg1.ogg', 'assets/audio/bckrg2.mp3']);

    },
    create: function () {
        //resizes game
        this.scale.scaleMode = Phaser.ScaleManager.USER_SCALE;
        console.log(parent.innerWidth + " " + parent.innerHeight);
        var scaleX = parent.innerWidth / this.game.width;
        var scaleY = parent.innerHeight / this.game.height;
        console.log(scaleX + " " + scaleY);
        var scaleAxis = scaleX > scaleY ? scaleX : scaleY;
        this.game.scale.setUserScale(scaleAxis, scaleY, 0, 0);
        this.game.scale.pageAlignVertically = true;
        this.game.scale.pageAlignHorizontally = true;
        console.log(this.camera.width + " " + this.camera.height);

        //loads Saved data
        this.loadInfo();
        if (this.loadedInfo === null) {
            saveData(1, false, 0, true, 1, true);
            saveHelpHint(true);
        }
        else {
            var data = JSON.parse(this.loadedInfo);
            GAMEMODE.openedLevels = parseInt(data.level);
            GAMEMODE.likedFB = data.liked;
            GAMEMODE.tutorial = data.tutorial;
            GAMEMODE.watchedAd = parseInt(data.watchedAd);
            MUSICMANAGER.musicON = data.musicON;
            MUSICMANAGER.volumeFXs = parseInt(data.volumeFXs);

            var hintData = JSON.parse(this.hintInfo);
            if (hintData) {
                GAMEMODE.helpTip = hintData.hintOn;
            }
        }

        $("#game").show();
        this.game.state.start("mainMenu");
    },
    loadInfo: function () {
        this.loadedInfo = localStorage.getItem("savedData");
        this.hintInfo = localStorage.getItem("helpHint");
    }
}