var level1 = function (game) { };
level1.prototype = {
    mouseX: 0,
    oldMouseX: 0,
    itemSelected: null,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_1/golema_kartina.png");
        this.load.image("tutorial", "assets/tutorial.png");
        this.load.spritesheet("okBtn", "assets/okBtn.png", 128, 64);
        this.load.spritesheet("smallscenes0", "assets/Level_1/smallscenes0.png", 1024, 768);
        this.load.spritesheet("smallscenes1", "assets/Level_1/smallscenes1.png", 1024, 768);
        this.load.spritesheet("box", "assets/Level_1/items/box.png", 532, 400);
        this.load.spritesheet("lqvaHartiq", "assets/Level_1/items/lqvaHartiq.png", 235, 645);
        this.load.spritesheet("dqsnaHartiq", "assets/Level_1/items/dqsnaHartiq.png", 235, 645);
        this.load.image("srednaHartiq", "assets/Level_1/items/srednaHartiq.png");

        //items
        this.load.image("knife", "assets/Level_1/items/knife.png");
        this.load.image("keyDiary", "assets/Level_1/items/keyDiary.png");
        this.load.image("bushon", "assets/Level_1/items/bushon.png");
        this.load.image("onlineSign", "assets/Level_1/items/onlineSign.png");
        this.load.image("bushonZareden", "assets/Level_1/items/bushonZareden.png");

        //hud items
        this.load.image("101", "assets/Level_1/HUD/101.png");
        this.load.image("102", "assets/Level_1/HUD/102.png");
        this.load.image("103", "assets/Level_1/HUD/103.png");

    },
    create: function () {
        resetHintTimer(true);

        //resetingShits and basic stuff for a level
        GAMEMODE.levelNumber = 1;
        GAMEMODE.pointerToLevel = this;
        this.cameraXBeforeSmallScene = 512;
        this.cameraMove = false;
        this.paused = false;
        this.videoPlaying = false;
        this.itemSelected = null;
        this.mouseX = 0;
        this.oldMouseX = 0;

        //stek sydyrjasht listove ot itemi, koito da se kriqt
        this.itemsToHide = [];
        setUpALevel(this);
        makeHUDItems(this);

        //reseting other basic variable sfor this particular level
        this.vaseUnlocked = false;
        this.doorOnline = false;
        var password = "";
        this.videoManager = {};
        this.videoManager[GAMEMODE.videoNames[0]] = false;
        this.videoManager[GAMEMODE.videoNames[1]] = false;
        this.videoManager[GAMEMODE.videoNames[2]] = false;

        //setting change scene members
        this.rightShelf = addActor(this, 1584, 346, "camera", 256, 156, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.rightShelf.id === 1) {
                    //ako shte gledame video
                    game.videoWalk.visible = true;
                }
                else if (game.rightShelf.id === 2) {
                    //ako sme napravo pred shkafa
                    game.fotka.visible = true;
                    if (!game.knife.taken)
                        game.knife.visible = true;
                }
            },
            getListToHide: function (game) {
                var returnV = [];
                if (game.rightShelf.id === 1)
                    returnV.push(game.videoWalk);
                else if (game.rightShelf.id === 2) {
                    returnV.push(game.fotka);
                    if (!game.knife.taken)
                        returnV.push(game.knife);
                }
                return returnV;
            }
        }, true);

        this.leftShelf = addActor(this, 277, 422, "camera", 256, 156, 4, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.leftShelf.id === 4) {
                    game.videoWalkTwo.visible = true;
                }
                else if (game.leftShelf.id === 5) {
                    game.dupkaBushon.visible = true;
                }
                else if (game.leftShelf.id === 6) {
                    game.listche.visible = true;
                }
            },
            getListToHide: function (game) {
                if (game.leftShelf.id === 4) {
                    return [game.videoWalkTwo];
                }
                else if (game.leftShelf.id === 5) {
                    return [game.dupkaBushon];
                }
                else if (game.leftShelf.id === 6) {
                    return [game.listche];
                }
            }
        }, true);

        this.centralShelf = addActor(this, 870, 298, "camera", 250, 120, 9, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.vaseUnlocked)
                    game.vase.visible = true;
                game.garderob.visible = true;
            },
            getListToHide: function (game) {
                return game.vaseUnlocked ? [game.vase, game.garderob] : [game.garderob];
            }
        }, true);

        this.door = addActor(this, 1140, 300, "camera", 150, 120, 7, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.doorOnline) {
                    game.onlineSign.visible = true;
                    game.doorKeyboard.visible = true;
                    game.doorPass.visible = true;
                }
            },
            getListToHide: function (game) {
                return game.doorOnline ? [game.onlineSign, game.doorKeyboard, game.doorPass] : null;
            }
        }, true);

        this.diary = addActor(this, 781, 555, "camera", 90, 100, 8, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.diary.id === 8) {
                    game.klyuchalka.visible = true;
                }
                else if (game.diary.id === 14) {
                    game.pageChanger.visible = true;
                    game.pageChanger.x = 518;
                }
            },
            getListToHide: function (game) {
                return game.diary.id === 8 ? [game.klyuchalka] : [game.pageChanger];
            }
        }, true);

        //change frame of the smallscene using handleSmallScenes
        //vazata
        this.vase = addActor(this, 741, 440, "camera", 180, 260, 11, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                if (!game.bushon.taken) {
                    game.bushon.visible = true;
                    game.itemsToHide.push([game.bushon]);
                }
            }
        }, false);

        //vhoda kym garderoba
        this.garderob = addActor(this, 407, 373, "camera", 326, 150, 10, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                game.box.visible = true;
                game.itemsToHide.push([game.box]);
            }
        }, false);

        //snimkata
        this.fotka = addActor(this, 388, 169, "camera", 200, 286, 3, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
            }
        }, false);

        //video actors handlers
        this.videoWalk = addActor(this, 290, 400, "camera", 512, 196, 111, true,
            this.videoHandler, { game: this, videoName: GAMEMODE.videoNames[0] }, false);
        this.videoWalkTwo = addActor(this, 398, 316, "camera", 468, 128, 112, true,
            this.videoHandler, { game: this, videoName: GAMEMODE.videoNames[1] }, false);

        //takeble items
        this.knife = addTakableItem(addActor(this, 713, 358, "knife", 174, 313, 101, true,
            takeItem, { game: this }, false));
        this.keyDiary = addTakableItem(addActor(this, 302, 259, "keyDiary", 410, 180, 102, true,
            takeItem, { game: this }, false));
        this.bushon = addTakableItem(addActor(this, 358, 372, "bushon", 173, 107, 103, true,
            takeItem, { game: this }, false));

        //others
        //kutiqta s kutiqta (OMGOMGOMG)
        this.box = addActor(this, 344, 339, "box", 434, 356, 301, true, function (e) {
            if (e.frame === 0) {
                if (this.itemSelected !== null && this.itemSelected.id === 101) {
                    e.frame = 1;
                    removeItemFromHUD(this);
                }
            }
            else {
                this.popListToHide();
                this.smallScene.id = 12;
                this.smallScene.frame = 3;
                this.showColour.show();
                this.showColour.putInHidingStack();
                this.showColour.checkIfCorrectCombo();
            }
        }, this, false);

        //klyuchalka na dnevnika
        this.klyuchalka = addActor(this, 531, 300, "camera", 180, 180, 302, true, function (e) {
            if (this.itemSelected !== null && this.itemSelected.id === 102) {
                removeItemFromHUD(this);
                this.diary.id = 14;

                this.smallScene.loadTexture("smallscenes1");
                this.smallScene.id = 14;
                this.smallScene.frame = 5;

                this.popListToHide();
                this.pageChanger.visible = true;
                this.itemsToHide.push([this.pageChanger]);
                e.destroy();
                e = null;
            }
        }, this, false);

        //handler za smenqne na stranici
        this.pageChanger = addActor(this, 518, 36, "camera", 440, 560, 303, true, function (e) {
            if (e.x === 518) {
                this.smallScene.id = 15;
                this.smallScene.frame = 6;
                e.x = 36;
                if (!this.vaseUnlocked)
                    this.vaseUnlocked = true;
            }
            else {
                this.smallScene.id = 14;
                this.smallScene.frame = 5;
                e.x = 518;
            }
        }, this, false);

        //tabelka za online
        this.onlineSign = addActor(this, 336, 55, "onlineSign", 229, 73, 304, false, null, this, false);

        //door keyboard
        this.doorKeyboard = addActor(this, 281, 276, "camera", 338, 440, 305, true, function (e) {
            var numberPressed = findNumber(this.game.input.x, this.game.input.y);
            if (password.length < 4 && numberPressed >= 0 && numberPressed <= 9) {
                password += numberPressed;
            }
            else if (numberPressed === 11) {
                password = "";
            }
            else if (numberPressed === 12) {
                if (password === "241") {
                    if (GAMEMODE.openedLevels === 1) {
                        GAMEMODE.openedLevels = 2;
                        saveData(GAMEMODE.openedLevels, GAMEMODE.likedFB, GAMEMODE.watchedAd, MUSICMANAGER.musicON, MUSICMANAGER.volumeFXs, GAMEMODE.tutorial);
                    }
                    this.state.start("Level2");
                }
                else {
                    password = "";
                }
            }
            this.doorPass.setText(password);
        }, this, false);

        //prigotvq bushon
        this.dupkaBushon = addActor(this, 487, 410, "camera", 100, 100, 306, true, function (e) {
            if (e.key === "camera" && this.itemSelected !== null && this.itemSelected.id === 103) {
                removeItemFromHUD(this);
                this.doorOnline = true;
                e.loadTexture("bushonZareden");
                setSizeActor(e, 100, 100);
                this.videoPlaying = true;
                setTimeout(function () {
                    GAMEMODE.pointerToLevel.videoHandler.apply({ game: GAMEMODE.pointerToLevel, videoName: GAMEMODE.videoNames[2] }, []);
                }, 1000);
            }
        }, this, false);

        //listche
        this.listche = addActor(this, 323, 265, "camera", 360, 206, 307, true, function (e) {
            this.paper.show();
        }, this, false);

        //text parola vrata
        this.doorPass = this.add.text(300, 186, "", { font: "64px Arial", fill: "#ffffff", align: "left" });
        this.doorPass.visible = false;

        //adding colors for the box
        this.showColour = {
            colorsCodes: [0x610707, 0x1C351A, 0xABAA4E],
            actors: [],
            show: function () {
                for (var i = 0; i < this.actors.length; i++) {
                    this.actors[i].visible = true;
                }
            },
            setUp: function () {
                for (var i = 0; i < this.actors.length; i++) {
                    this.actors[i].col = 0;
                    //changes the colour s 16- no 4islo
                    this.actors[i].tint = this.colorsCodes[this.actors[i].col];
                }
            },
            putInHidingStack: function () {
                GAMEMODE.pointerToLevel.itemsToHide.push(this.actors);
            },
            checkIfCorrectCombo: function () {
                if (this.actors[0].col === 1 && this.actors[1].col === 0 && this.actors[2].col === 2) {
                    GAMEMODE.pointerToLevel.popListToHide();
                    GAMEMODE.pointerToLevel.smallScene.id = 13;
                    GAMEMODE.pointerToLevel.smallScene.frame = 4;

                    if (!GAMEMODE.pointerToLevel.keyDiary.taken) {
                        GAMEMODE.pointerToLevel.keyDiary.visible = true;
                        GAMEMODE.pointerToLevel.itemsToHide.push([GAMEMODE.pointerToLevel.keyDiary]);
                    }
                }
            },
            switchColor: function (e) {
                e.col = ((e.col + 1) % 3);
                e.tint = GAMEMODE.pointerToLevel.showColour.colorsCodes[e.col];
                GAMEMODE.pointerToLevel.showColour.checkIfCorrectCombo();
            }
        };
        this.showColour.actors.push(addActor(this, 230, 87, "tester", 172, 480, 201, true,
            this.showColour.switchColor, this, false));
        this.showColour.actors.push(addActor(this, 411, 87, "tester", 172, 480, 202, true,
            this.showColour.switchColor, this, false));
        this.showColour.actors.push(addActor(this, 594, 87, "tester", 172, 480, 203, true,
            this.showColour.switchColor, this, false));

        this.showColour.setUp();

        //adding object for the paper game
        this.paper = {
            leftPart: null,
            middlePart: null,
            rightPart: null,
            changePaper: function (e) {
                if (e.frame === 0) {
                    e.frame = 1;
                    if (e.id === 308) {
                        e.y = 48;
                        e.x = 235;
                    }
                    if (e.id === 309) {
                        e.y = 58;
                        e.x = 586;
                    }
                }
            },
            show: function () {
                this.leftPart.visible = true;
                this.middlePart.visible = true;
                this.rightPart.visible = true;
                GAMEMODE.pointerToLevel.itemsToHide.push([this.leftPart, this.rightPart, this.middlePart]);
            },
            setUp: function () {
                this.leftPart = addActor(GAMEMODE.pointerToLevel, 207, 49, "lqvaHartiq", 235, 645, 308, true,
                    this.changePaper, GAMEMODE.pointerToLevel, false);
                this.middlePart = addActor(GAMEMODE.pointerToLevel, 394, 47, "srednaHartiq", 257, 645, 310, false,
                    null, null, false);
                this.rightPart = addActor(GAMEMODE.pointerToLevel, 606, 56, "dqsnaHartiq", 235, 645, 309, true,
                    this.changePaper, GAMEMODE.pointerToLevel, false);
            }
        };
        this.paper.setUp();

        if (GAMEMODE.tutorial) {
            this.paused = true;
            this.tutorial = addActor(GAMEMODE.pointerToLevel, 256, 192, "tutorial", 512, 386, 308, true, function () { }, {}, true);
            this.okBtn = this.add.button(448, 475, "okBtn", function (e) {
                this.paused = false;
                GAMEMODE.tutorial = false;
                this.tutorial.destroy();
                e.kill();
            }, this, 0, 0, 1);
        }

    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1536)
                    this.cameraMan.x = 1536;
                else if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                //compute the kolelce new frame
                var razlika = this.mouseX - this.kolelce.lastMoved;
                if (Math.abs(razlika) > 20 && this.cameraMan.x != 512 && this.cameraMan.x != 1536) {
                    var direction = razlika > 0 ? -1 : 1;
                    this.kolelce.frame = this.kolelce.frame === 0 && direction === -1 ? 2 : (this.kolelce.frame + direction) % 3;
                    this.kolelce.lastMoved = this.mouseX;
                }

                this.oldMouseX = this.mouseX;
            }
            this.HUD.bringToTop();
            for (var i = 0; i < 4; i++)
                this.hudItems[i].bringToTop();
            this.selector.bringToTop();
        }
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.event.paused) {
            //resets cameraview
            this.event.cameraXBeforeSmallScene = this.event.cameraMan.x;
            this.event.cameraMan.x = 512;

            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
                this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
            this.scene.frame = (e.id - 1) % 8;
            this.scene.shown = true;

            //ako trqbva specialni neshta ako trqbva da se pokajat
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);

            //vkarva list s itemite koito trqbva da se skriqt
            if (this.getListToHide) {
                var list = this.getListToHide(this.event);
                if (list) {
                    this.event.itemsToHide.push(list);
                }
            }
            //adds back Btnton
            var backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
            this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
        this.scene.id = e.id;
        this.scene.frame = (e.id - 1) % 8;
        if (this.visibilityAndActionHandler)
            this.visibilityAndActionHandler(this.event);
    },
    videoHandler: function (e) {
        var pointerToThis = this;
        if (!this.game.videoManager[this.videoName]) {
            //otbelqzva tova video kato gledano
            this.game.videoManager[this.videoName] = true;

            //pause music videoto
            if (MUSICMANAGER.musicON || MUSICMANAGER.volumeFXs === 1) {
                pauseMusicForVideo();
            }

            GAMEMODE.pointerToLevel.videoPlaying = true;
            playPlayer(game.videos[this.videoName]);
            setTimeout(function () {
                game.videos[pointerToThis.videoName].callback();
                e.destroy();
                e = null;
            }, 2000);
        }
    },
    backBtnHandler: function (e) {
        if (!this.videoPlaying) {
            this.event.cameraMan.x = this.event.cameraXBeforeSmallScene;
            this.scene.width = 0;
            this.scene.height = 0;
            this.scene.id = -1;
            this.scene.shown = false;

            while (this.event.itemsToHide.length > 0)
                this.event.popListToHide();
            e.kill();
            e = null;
        }
    },
    popListToHide: function () {
        var list = this.itemsToHide.pop();
        for (var i = 0; i < list.length; i++)
            if (list[i] && list[i].visible)
                list[i].visible = false;
    }

};
