var level2 = function (game) { };
level2.prototype = {
    mouseX: 0,
    oldMouseX: 0,
    itemSelected: null,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_2/background.png");
        this.load.spritesheet("smallscenes0", "assets/Level_2/smallscenes0.png", 1024, 768);
        this.load.spritesheet("smallscenes1", "assets/Level_2/smallscenes1.png", 1024, 768);
        this.load.image("otr", "assets/Level_2/otr.png");
        this.load.image("hole", "assets/Level_2/hole.png");
        this.load.image("razbitaStena", "assets/Level_2/razbitaStena.png");
        this.load.image("skica", "assets/Level_2/skica.png");
        this.load.image("topche", "assets/Level_2/topche.png");

        this.load.image("boardgame", "assets/Level_2/logicGame/boardgame.png");
        this.load.image("cards", "assets/Level_2/logicGame/cards.png");
        this.load.image("cards2", "assets/Level_2/logicGame/cards2.png");

        //items
        this.load.image("perde", "assets/Level_2/items/perde.png");
        this.load.image("ogledalo", "assets/Level_2/items/ogledalo.png");
        this.load.image("musicBox", "assets/Level_2/items/musicBox.png");
        this.load.image("books", "assets/Level_2/items/books.png");
        this.load.spritesheet("walky", "assets/Level_2/walky.png", 189, 484);
        this.load.image("chuk", "assets/Level_2/items/chuk.png");
        this.load.image("drelka", "assets/Level_2/items/drelka.png");
        this.load.image("light", "assets/Level_2/items/light.png");

        //hud items
        this.load.image("201", "assets/Level_2/HUD/201.png");
        this.load.image("202", "assets/Level_2/HUD/202.png");
        this.load.image("203", "assets/Level_2/HUD/203.png");
        this.load.image("204", "assets/Level_2/HUD/204.png");
        this.load.image("205", "assets/Level_2/HUD/205.png");

    },
    create: function () {
        resetHintTimer(true);

        //resetingShits and basic stuff for a level
        GAMEMODE.levelNumber = 2;
        GAMEMODE.pointerToLevel = this;
        this.cameraXBeforeSmallScene = 512;
        this.cameraMove = false;
        this.paused = false;
        this.videoPlaying = false;
        this.itemSelected = null;
        this.mouseX = 0;
        this.oldMouseX = 0;

        //stek sydyrjasht listove ot itemi, koito da se kriqt
        this.itemsToHide = [];
        //list sydyrjasht actiori, koito moje da tick- vat
        this.tickingActors = {};
        setUpALevel(this);
        makeHUDItems(this);

        //reseting other basic variable sfor this particular level
        this.videoManager = {};
        this.videoManager[GAMEMODE.videoNames[3]] = false;
        this.videoManager[GAMEMODE.videoNames[4]] = false;
        this.videoManager[GAMEMODE.videoNames[5]] = false;
        var password = "";
        this.saveOpened = false;

        //Adding actors for this scene only
        this.logicGame = this.createLogicGame();

        this.walkyTalky = this.createWalkyTalky();
        this.tickingActors["WalkyTalky"] = this.walkyTalky;

        //chuk na scena za golqma scena
        this.chukInRoom = addActor(this, 1135, 169, "chuk", 159, 70, 951, false, {}, {}, true);

        //Adding actors that change the scenes
        this.wall = addActor(this, 342, 140, "camera", 156, 230, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.perde) {
                    game.perde.mainActor.visible = true;
                }
                if (game.ogledalo) {
                    game.ogledalo.visible = true;
                }
                if (game.otr) {
                    game.otr.show();
                }
                if (game.dupka) {
                    game.dupka.visible = true;
                    if (game.musicBox) {
                        game.musicBox.visible = true;
                    }
                }
            },
            getListToHide: function (game) {
                var returnV = [];
                if (game.perde) {
                    returnV.push(game.perde.mainActor);
                }
                if (game.ogledalo) {
                    returnV.push(game.ogledalo);
                }
                if (game.otr) {
                    var actorsList = game.otr.getListOfActors();
                    actorsList.forEach(function (e) {
                        returnV.push(e);
                    });
                }
                if (game.dupka) {
                    returnV.push(game.dupka);
                    if (game.musicBox) {
                        returnV.push(game.musicBox);
                    }
                }

                return returnV;
            }
        }, true);
        this.bookShelf = addActor(this, 1618, 217, "camera", 200, 150, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.books) {
                    game.books.visible = true;
                }
                game.podMasa.visible = true;
            },
            getListToHide: function (game) {
                var returnV = [];
                if (game.books) {
                    returnV.push(game.books);
                }
                returnV.push(game.podMasa);
                return returnV;
            }
        }, true);
        this.masaInstrumenti = addActor(this, 1144, 303, "camera", 299, 94, 4, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.hammer.taken) {
                    game.hammer.visible = true;
                }
                if (!game.drelka.taken) {
                    game.drelka.visible = true;
                }
            },
            getListToHide: function (game) {
                var retV = [];
                if (!game.hammer.taken) {
                    retV.push(game.hammer);
                }
                if (!game.drelka.taken) {
                    retV.push(game.drelka);
                }
                return retV;
            }
        }, true);
        this.masaSredna = addActor(this, 802, 416, "camera", 505, 105, 5, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.masaSredna.id === 5) {
                    game.gameOnTable.visible = true;
                }
            },
            getListToHide: function (game) {
                if (game.masaSredna.id === 5) {
                    return [game.gameOnTable];
                }
                else
                    return null;
            }
        }, true);
        this.door = addActor(this, 0, 380, "camera", 100, 100, 8, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.doorLock.show();
            },
            getListToHide: function (game) {
                return game.doorLock.returnListOfActors();
            }
        }, true);
        //change frame of the smallscene using handleSmallScenes
        this.podMasa = addActor(this, 661, 461, "camera", 120, 100, 3, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                game.list.visible = true;
                game.itemsToHide.push([game.list]);
            }
        }, false);
        //items
        //kutiq
        this.musicBox = null;
        this.books = addActor(this, 148, 291, "books", 157, 119, 6, true, function (e) {
            if (e.key === "books") {
                var width = e.width, height = e.height;
                e.loadTexture("camera");
                setSizeActor(e, width, height);
            }
            else {
                //load safe
                this.handleSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityAndActionHandler: function (game) {
                        game.popListToHide();
                        console.log(game.saveOpened);
                        if (!game.saveOpened) {
                            game.safeKeyboard.visible = true;
                            game.doorPass.visible = true;

                            game.itemsToHide.push([game.safeKeyboard, game.doorPass]);
                        }
                        else {
                            //if it's opened if the light is taken or not
                            //the light will play the video
                            if (!game.light.taken) {
                                game.light.visible = true;
                                game.itemsToHide.push([game.light]);
                            }
                        }
                    }
                }, [e]);
            }
        }, this, false);
        //chuk na stena
        this.hammer = addTakableItem(addActor(this, 147, 0, "chuk", 442, 195, 201, true, function (e) {
            if (this.chukInRoom) {
                this.chukInRoom.destroy();
                this.chukInRoom = null;
            }
            takeItem.apply({ game: this }, [e]);
        }, this, false));
        //drelka
        this.drelka = addTakableItem(addActor(this, 17, 553, "drelka", 441, 211, 203, true,
takeItem, { game: this }, false));
        //fenereche
        this.light = addActor(this, 309, 602, "light", 290, 142, 202, true, function (e) {
            this.videoHandler.apply({ game: this, videoName: GAMEMODE.videoNames[3] }, []);
        }, this, false);

        //others
        //walky talky in the scene
        this.walkyTalkyBox = addActor(this, 342, 399, "camera", 100, 100, 100, true, function () {
            if (!this.paused && !this.smallScene.shown) {
                this.walkyTalky.show();
            }
        }, this, true);
        //ogledalo
        this.ogledalo = addActor(this, 343, 84, "ogledalo", 334, 684, 101, true, function (e) {
            if (e.key === "ogledalo") {
                var w = e.width;
                var h = e.height;
                e.loadTexture("camera");
                setSizeActor(e, w, h);
            }
            else if (this.itemSelected !== null && this.itemSelected.id === 202) {
                removeItemFromHUD(this);
                this.otr = this.createOtr();

                var sound = MUSICMANAGER["laugh_" + getRandomIntInclusive(1, 3)];
                if (sound) {
                    sound.play();
                }

                this.otr.show();
                this.popListToHide();
                var actorsList = this.otr.getListOfActors();
                this.itemsToHide.push(actorsList);

                e.destroy();
                this.ogledalo = null;
            }
        }, this, false);
        //perde
        this.perde = this.createPerde();
        this.tickingActors["Perde"] = this.perde;
        //otrajenie
        this.otr = null;
        //dupka
        this.dupka = null;
        //listche
        this.list = addActor(this, 309, 253, "camera", 256, 256, 105, true, function (e) {
            if (!this.skica.visible) {
                this.skica.visible = true;
                var backBtn = this.add.button(10, 630, "backBtn", function (e) {
                    if (this.skica.visible) {
                        this.skica.visible = false;
                        e.kill();
                        backBtn = null;
                    }
                }, this, 0, 0, 1);
            }
        }, this, false);
        //skica
        this.skica = addActor(this, 0, 0, "skica", 1024, 768, 950, false, {}, {}, false);
        //safe keyboard
        this.safeKeyboard = addActor(this, 281, 276, "camera", 338, 440, 305, true, function (e) {
            var numberPressed = findNumber(this.game.input.x, this.game.input.y);
            if (password.length < 5 && numberPressed >= 0 && numberPressed <= 9) {
                password += numberPressed;
            }
            else if (numberPressed === 11) {
                password = "";
            }
            else if (numberPressed === 12) {
                if (password === "5891") {
                    this.popListToHide();

                    this.smallScene.id = 7;
                    this.smallScene.frame = 6;

                    this.books.id = 7;
                    this.saveOpened = true;

                    this.light.visible = true;
                    this.itemsToHide.push([this.light]);
                }
                else {
                    password = "";
                }
            }
            this.doorPass.setText(password);
        }, this, false);
        //text parola vrata
        this.doorPass = this.add.text(300, 186, "", { font: "64px Arial", fill: "#ffffff", align: "left" });
        this.doorPass.visible = false;
        //igra na masa
        this.gameOnTable = addActor(this, 70, 394, "camera", 300, 200, 106, true, function (e) {
            if (!this.paused) {
                ////mahni malkata scena
                this.backBtnHandler.apply({
                    event: this,
                    scene: this.smallScene
                }, [this.backBtn]);
                //premesti da se vijda vsi4ko i pusni logic game- a 
                this.cameraMan.x = 512;
                this.logicGame.setUp();
            }
        }, this, false);
        //klyuchalka
        this.doorLock = this.createDoorLock();
        //showing the HUD above everything else
        this.bringHUDToTop();

        //show ad
        showInterstitial();
    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1536)
                    this.cameraMan.x = 1536;
                else if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                //compute the kolelce new frame
                var razlika = this.mouseX - this.kolelce.lastMoved;
                if (Math.abs(razlika) > 20 && this.cameraMan.x != 512 && this.cameraMan.x != 1536) {
                    var direction = razlika > 0 ? -1 : 1;
                    this.kolelce.frame = this.kolelce.frame === 0 && direction === -1 ? 2 : (this.kolelce.frame + direction) % 3;
                    this.kolelce.lastMoved = this.mouseX;
                }

                this.oldMouseX = this.mouseX;
            }
        }
        for (var property in this.tickingActors) {
            if (this.tickingActors.hasOwnProperty(property) && this.tickingActors[property].isTicking) {
                this.tickingActors[property].tick();
            }
        }
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.event.paused) {
            //resets cameraview
            this.event.cameraXBeforeSmallScene = this.event.cameraMan.x;
            this.event.cameraMan.x = 512;

            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
                this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
            this.scene.frame = (e.id - 1) % 8;
            this.scene.shown = true;

            //ako trqbva specialni neshta ako trqbva da se pokajat
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);

            //vkarva list s itemite koito trqbva da se skriqt
            if (this.getListToHide) {
                var list = this.getListToHide(this.event);
                if (list) {
                    this.event.itemsToHide.push(list);
                }
            }
            //adds back Btnton
            this.event.backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
            this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
        this.scene.id = e.id;
        this.scene.frame = (e.id - 1) % 8;
        if (this.visibilityAndActionHandler)
            this.visibilityAndActionHandler(this.event);
    },
    videoHandler: function (e) {
        var pointerToThis = this;
        if (!this.game.videoManager[this.videoName]) {
            //otbelqzva tova video kato gledano
            this.game.videoManager[this.videoName] = true;

            //pause music videoto
            if (MUSICMANAGER.musicON || MUSICMANAGER.volumeFXs === 1) {
                pauseMusicForVideo();
            }

            GAMEMODE.pointerToLevel.videoPlaying = true;
            playPlayer(game.videos[this.videoName]);
            setTimeout(function () {
                game.videos[pointerToThis.videoName].callback();
                if (e) {
                    e.destroy();
                    e = null;
                }
            }, 2000);
        }
    },
    backBtnHandler: function (e) {
        if (!this.videoPlaying) {
            this.event.cameraMan.x = this.event.cameraXBeforeSmallScene;
            this.scene.width = 0;
            this.scene.height = 0;
            this.scene.id = -1;
            this.scene.shown = false;

            while (this.event.itemsToHide.length > 0)
                this.event.popListToHide();
            e.kill();
            this.event.backBtn = null;
        }
    },
    popListToHide: function () {
        var list = this.itemsToHide.pop();
        for (var i = 0; i < list.length; i++)
            if (list[i] && list[i].visible)
                list[i].visible = false;
    },
    bringHUDToTop: function () {
        this.HUD.bringToTop();
        for (var i = 0; i < 4; i++)
            this.hudItems[i].bringToTop();
        this.selector.bringToTop();
    },
    createLogicGame: function () {
        var objToReturn = {};
        objToReturn.createAnswerBox = function (index) {
            var pointerToObj = this;
            function onConfirm(btnPressed) {
                if (btnPressed > 1) {
                    var answerGiven = btnPressed === 2 ? true : false;
                    if (answerGiven === pointerToObj.boxInformation[index].value) {
                        pointerToObj.markBoxAsAnswered(index);
                        if (pointerToObj.answered === 12) {
                            pointerToObj.endGame();
                        }
                    }
                    else {
                        function wrongAnswerHandler(btnPressed) {
                            if (btnPressed === 2) {
                                pointerToObj.destroyActors();
                                pointerToObj.backBtn.destroy();
                                pointerToObj.backBtn = null;
                                pointerToObj.setUp();
                            }
                            else {
                                pointerToObj.destroyActors();
                                pointerToObj.backBtn.destroy();
                                pointerToObj.backBtn = null;
                                GAMEMODE.pointerToLevel.paused = false;
                            }
                        }
                        navigator.notification.confirm(
                            "You answered wrong. The value of this box is " + pointerToObj.boxInformation[index].value, // message
                             wrongAnswerHandler, // callback to invoke with index of button pressed
                             "Wrong answer", // title
                             ["Back To Room", "Restart"] // buttonLabels
                        );
                    }
                }
            }
            navigator.notification.confirm(
                "What is the value in this box?", // message
                onConfirm, // callback to invoke with index of button pressed
                this.boxInformation[index].key, // title
                ["Back", "True", "False"] // buttonLabels
            );
        }
        objToReturn.markBoxAsAnswered = function (index) {
            this.boxes[index].isAnswered = true;
            this.boxes[index].loadTexture("cards2");
            this.boxes[index].tint = this.facts[index].split('\n')[0] === "TRUE:" ? 0xB3F8BF : 0xEAF189;

            //draw information Text
            this.texts.push(GAMEMODE.pointerToLevel.add.text(this.boxes[index].x + this.boxes[index].width * 0.05, this.boxes[index].y + this.boxes[index].height * 0.05,
                this.facts[index],
                { font: "64px Arial", fill: "#000000", align: "center" }));
            var textAdded = this.texts[this.texts.length - 1];
            var coefWidth = (this.boxes[index].width * 0.9) / textAdded.width, coefHeight = (this.boxes[index].height * 0.9) / textAdded.height;
            var coef = coefWidth < coefHeight ? coefWidth : coefHeight;
            setSizeActor(textAdded, textAdded.width * coef, textAdded.height * coef);

            this.answered++;
        }
        objToReturn.facts = [
            "TRUE:\n A3 and B3 \n are true. ",
            "FALSE:\n There is a column \n where all the answers \n are the same. ",
            "TRUE:\n Any false boxes \n in the corner are \n not adjacent to any \n other false boxes.",
            "TRUE:\n All even numbers \n in row B are false. ",
            "FALSE:\n This column does \n not have more \n true boxes than \n the second one.",
            "FALSE:\n It's not true,\n that B1 is false. ",
            "TRUE:\n This box is the \n opposite of B4. ",
            "FALSE:\n C1 is false \n ",
            "TRUE:\n This box is \n adjacent to 1 \n true box. ",
            "TRUE:\n Petko is \n watching you.",
            "FALSE:\n two plus two \n equals 3 ",
            "TRUE:\n This box is \n the opposite \n of not useful."
        ];
        objToReturn.background = null;
        objToReturn.backBtn = null;
        objToReturn.boxes = [];
        objToReturn.texts = [];
        objToReturn.answered = 0;
        objToReturn.done = false;
        objToReturn.boxInformation = [
            {
                key: "A1",
                value: true
            },
            {
                key: "A2",
                value: false
            },
            {
                key: "A3",
                value: true
            },
            {
                key: "A4",
                value: true
            },
            {
                key: "B1",
                value: false
            },
            {
                key: "B2",
                value: false
            },
            {
                key: "B3",
                value: true
            },
            {
                key: "B4",
                value: false
            },
            {
                key: "C1",
                value: true
            },
            {
                key: "C2",
                value: true
            },
            {
                key: "C3",
                value: false
            },
            {
                key: "C4",
                value: true
            }
        ];
        objToReturn.endGame = function () {
            this.done = true;
            this.boxes.forEach(function (e) {
                e.kill();
            });
            this.texts.forEach(function (e) {
                e.visible = false;
            });
        };
        objToReturn.setUp = function () {
            GAMEMODE.pointerToLevel.paused = true;
            if (!this.done) {
                this.answered = 0;
                var indexCounter = 0;
                objToReturn.background = addActor(GAMEMODE.pointerToLevel, 0, 0, "boardgame", 1024, 768, 950, true, function () { }, {}, true);
                objToReturn.backBtn = GAMEMODE.pointerToLevel.add.button(0, 0, "backBtn", function (e) {
                    objToReturn.destroyActors();
                    e.kill();
                    e = null;
                    GAMEMODE.pointerToLevel.paused = false;
                }, this, 0, 0, 1);
                for (var i = 0; i < 3; i++) {
                    var startingX = 65;
                    var startingY = 178 + (i * 189);
                    for (var j = 0; j < 4; j++) {
                        this.boxes.push(addActor(GAMEMODE.pointerToLevel, startingX + (j * 241), startingY, "cards", 225, 175, 900 + indexCounter, true, function (e) {
                            if (e.isAnswered) {
                                //show the text in a box
                                var prepared = objToReturn.facts[e.id - 900].replace(/(?:\r\n|\r|\n)/g, '');;

                                navigator.notification.alert(
                                    prepared,  // message
                                    function () { },         // callback
                                    'Tip',            // title
                                    'OK'                  // buttonName
                                    );
                            }
                            else {
                                this.createAnswerBox(e.id - 900);
                            }
                        }, this, true));
                        objToReturn.boxes[indexCounter].isAnswered = false;
                        indexCounter++;
                    }
                }
                this.markBoxAsAnswered(0);
            }
            else {
                objToReturn.background = addActor(GAMEMODE.pointerToLevel, 0, 0, "boardgame", 1024, 768, 950, true, function () { }, {}, true);
                objToReturn.backBtn = GAMEMODE.pointerToLevel.add.button(0, 0, "backBtn", function (e) {
                    objToReturn.destroyActors();
                    e.kill();
                    e = null;
                    GAMEMODE.pointerToLevel.paused = false;
                }, this, 0, 0, 1);
            }
        };
        objToReturn.destroyActors = function () {
            if (objToReturn.background) {
                objToReturn.background.destroy();
                objToReturn.background = null;
            }
            this.boxes.forEach(function (e) {
                e.destroy();
                e = null;
            });
            this.boxes = [];
            this.texts.forEach(function (e) {
                e.destroy();
                e = null;
            });
            this.texts = [];
        };
        return objToReturn;
    },
    createWalkyTalky: function () {
        var walkyTalky = {};

        walkyTalky.startX = 0;
        walkyTalky.isSpinning = false;
        walkyTalky.isOpened = false;
        walkyTalky.isTicking = false;

        //  Main spritesheet that represents the walky talky
        walkyTalky.mainActor = addActor(this, 418, 142, "walky", 189, 484, 801, true, function (e) {
            if (walkyTalky.isSpinning) {
                walkyTalky.isSpinning = false;
            }
        }, this, false);

        walkyTalky.mainActor.events.onInputDown.add(function (e) {
            if (!walkyTalky.isOpened) {
                walkyTalky.isSpinning = true;
                walkyTalky.startX = this.input.x;
            }
        }, this);

        // The clip that should be clicked in order to open the walky talky
        walkyTalky.backClip = addActor(this, 457, 475, "camera", 122, 100, 204, true, function (e) {
        }, this, false);
        walkyTalky.backClip.taken = false;

        walkyTalky.backClip.events.onInputDown.add(function (e) {
            if (!walkyTalky.isOpened) {
                walkyTalky.mainActor.frame = 19;
                walkyTalky.isOpened = true;
            }
            else {
                takeItem.apply({ game: this }, [e]);
                //destroy the actors and give the item
                walkyTalky.hide();
                walkyTalky.backBtn.destroy();
                walkyTalky.destroy();
            }
        }, this);

        walkyTalky.show = function () {
            GAMEMODE.pointerToLevel.paused = true;
            GAMEMODE.pointerToLevel.cameraMan.x = 512;
            walkyTalky.isTicking = true;
            walkyTalky.mainActor.visible = true;
            if (walkyTalky.isOpened) {
                walkyTalky.backClip.visible = true;
            }

            walkyTalky.backBtn = GAMEMODE.pointerToLevel.add.button(10, 630, "backBtn", function (e) {
                walkyTalky.hide();
                e.kill();
                walkyTalky.backBtn = null;
            }, this, 0, 0, 1);
        }

        walkyTalky.hide = function () {
            GAMEMODE.pointerToLevel.paused = false;
            walkyTalky.isTicking = false;
            walkyTalky.mainActor.visible = false;
            walkyTalky.backClip.visible = false;

            if (!walkyTalky.isOpened) {
                walkyTalky.mainActor.frame = 0;
            }
        }

        walkyTalky.destroy = function () {
            walkyTalky.mainActor.destroy();
            walkyTalky.mainActor = null;
            walkyTalky.backClip.destroy();
            walkyTalky.backClip = null;
            GAMEMODE.pointerToLevel.walkyTalkyBox.destroy();
            GAMEMODE.pointerToLevel.walkyTalkyBox = null;

            delete GAMEMODE.pointerToLevel.tickingActors["WalkyTalky"];
        }

        walkyTalky.tick = function () {
            if (walkyTalky.isSpinning) {
                var thisX = GAMEMODE.pointerToLevel.input.x;
                if (Math.abs(walkyTalky.startX - thisX) > 20) {
                    var direction = walkyTalky.startX - thisX > 0 ? 1 : -1;
                    walkyTalky.startX -= (direction * 20);

                    var frameNow = walkyTalky.mainActor.frame;
                    walkyTalky.mainActor.frame = frameNow === 0 && direction === -1 ? 18 : (frameNow + direction) % 19;

                    //shows the clip
                    frameNow = walkyTalky.mainActor.frame;
                    if (frameNow >= 7 && frameNow <= 10 && !walkyTalky.backClip.visible) {
                        walkyTalky.backClip.visible = true;
                    }
                    else if (walkyTalky.backClip.visible && (frameNow < 7 || frameNow > 10)) {
                        walkyTalky.backClip.visible = false;
                    }
                }
            }
        }
        return walkyTalky;
    },
    createPerde: function () {
        var perde = {};
        perde.isTicking = false;

        perde.mainActor = addActor(this, 145, 15, "perde", 552, 755, 803, true, function (e) {
            perde.isTicking = false;
        }, this, false);
        perde.mainActor.startX = 0;

        perde.mainActor.events.onInputDown.add(function (e) {
            perde.isTicking = true;
            perde.mainActor.startX = this.input.x;
        }, this);

        perde.tick = function () {
            if (GAMEMODE.pointerToLevel.input.x) {
                if (perde.mainActor.startX - GAMEMODE.pointerToLevel.input.x > perde.mainActor.width / 3) {
                    perde.mainActor.destroy();
                    perde.mainActor = null;
                    GAMEMODE.pointerToLevel.perde = null;

                    delete GAMEMODE.pointerToLevel.tickingActors["Perde"];
                }
            }
        }

        return perde;
    },
    createOtr: function () {
        var otr = {};
        otr.mainActor = addActor(this, 292, 48, "otr", 400, 400, 804, true, function (e) {
            if (otr.broiDupki === 5 && this.itemSelected !== null && this.itemSelected.id === 201) {
                removeItemFromHUD(this);
                this.dupka = addActor(this, 338, 184, "razbitaStena", 279, 194, 103, false, {}, {}, true);
                this.musicBox = addActor(this, 430, 266, "musicBox", 100, 64, 150, true, function (e) {
                    //play the video switch scenes and stuff with items to hide and change the smallcene to the final one also
                    //change the id of the table so it shows the final scene
                    this.videoHandler.apply({ game: this, videoName: GAMEMODE.videoNames[4] }, []);
                    e.detroy();
                    this.musicBox = null;
                }, this, true);
                this.popListToHide();
                this.itemsToHide.push([this.dupka, this.musicBox]);

                otr.destroy();
            }
        }, this, false);

        otr.dupki = [];
        function makeHole(e) {
            if (e.key === "camera" && this.itemSelected !== null && this.itemSelected.id === 205) {
                e.loadTexture("hole");
                setSizeActor(e, 50, 50);
                e.inputEnabled = false;
                otr.broiDupki++;
                if (otr.broiDupki === 5) {
                    removeItemFromHUD(this);
                }
            }
        }
        otr.dupki.push(addActor(this, 408, 221, "camera", 50, 50, 805, true, makeHole, this, false));
        otr.dupki.push(addActor(this, 516, 222, "camera", 50, 50, 805, true, makeHole, this, false));
        otr.dupki.push(addActor(this, 465, 268, "camera", 50, 50, 805, true, makeHole, this, false));
        otr.dupki.push(addActor(this, 395, 305, "camera", 50, 50, 805, true, makeHole, this, false));
        otr.dupki.push(addActor(this, 541, 302, "camera", 50, 50, 805, true, makeHole, this, false));

        otr.broiDupki = 0;

        otr.show = function () {
            otr.mainActor.visible = true;
            otr.dupki.forEach(function (e) {
                e.visible = true;
            });
        };

        otr.getListOfActors = function () {
            var retV = [];
            retV.push(otr.mainActor);
            otr.dupki.forEach(function (e) {
                retV.push(e);
            });
            return retV;
        }

        otr.destroy = function () {
            otr.mainActor.destroy();
            otr.mainActor = null;
            otr.dupki.forEach(function (e) {
                e.destroy();
                e = null;
            });
            otr.dupki = null;
            GAMEMODE.pointerToLevel.otr = null;
        }

        return otr;
    },
    createDoorLock: function () {
        var lock = {};
        lock.dupki = [];
        lock.coordsX = [202, 310, 417, 523];
        lock.coordsY = [183, 286, 390, 499];
        lock.checkIfWin = function () {
            return lock.dupki[0].id === 1 && lock.dupki[1].id === 2 && lock.dupki[2].id === 0 && lock.dupki[3].id === 3;
        }
        function changePostion(e) {
            e.id = (e.id + 1) % 4;
            e.x = lock.coordsX[e.id];

            if (lock.checkIfWin()) {
                this.videoHandler.apply({ game: this, videoName: GAMEMODE.videoNames[5] }, []);
            }
        }
        lock.dupki.push(addActor(this, lock.coordsX[0], lock.coordsY[0], "topche", 95, 95, 0, true, changePostion, this, false));
        lock.dupki.push(addActor(this, lock.coordsX[0], lock.coordsY[1], "topche", 95, 95, 0, true, changePostion, this, false));
        lock.dupki.push(addActor(this, lock.coordsX[0], lock.coordsY[2], "topche", 95, 95, 0, true, changePostion, this, false));
        lock.dupki.push(addActor(this, lock.coordsX[0], lock.coordsY[3], "topche", 95, 95, 0, true, changePostion, this, false));

        lock.show = function () {
            lock.dupki.forEach(function (e) {
                e.visible = true;
            });
        }

        lock.returnListOfActors = function () {
            return lock.dupki;
        }
        return lock;
    }

};
