var mainMenu = function (game) { };
mainMenu.prototype = {

    preload: function () {
        //resets variables
        this.videoPlaying = false;
        GAMEMODE.levelNumber = 0;
        GAMEMODE.pointerToLevel = this;

        this.load.image("backgroundMainMenu", "assets/mainMenu/mainMenu_backGround.png");
        this.load.spritesheet("ochki_desni", "assets/mainMenu/ochki_desni.png", 128, 64);
        this.load.spritesheet("ochki_levi", "assets/mainMenu/ochki_levi.png", 128, 64);
        this.load.spritesheet("startBtn", "assets/mainMenu/menuStartBtn.png", 256, 110);
        this.load.spritesheet("exitBtn", "assets/mainMenu/exit_che.png", 194, 77);
        this.load.spritesheet("btnCredits", "assets/mainMenu/btnCredits.png", 256, 110);
        this.load.spritesheet("backMenuBtn", "assets/mainMenu/backMenuBtn.png", 128, 64);
        this.load.spritesheet("lv1Btn", "assets/mainMenu/lv1Btn.png", 128, 128);
        this.load.spritesheet("lv2Btn", "assets/mainMenu/lv2Btn.png", 128, 128);
        this.load.spritesheet("lv3Btn", "assets/mainMenu/lv3Btn.png", 128, 128);
        this.load.spritesheet("lv4Btn", "assets/mainMenu/lv4Btn.png", 128, 128);
        this.load.spritesheet("lv5Btn", "assets/mainMenu/lv5Btn.png", 128, 128);
        this.load.image("credits", "assets/credits.png");

        //main
        this.load.image("camera", "assets/prazno.png");
        this.load.image("tester", "assets/prazno2.png");
        this.load.image("HUD", "assets/hud2.png");
        this.load.spritesheet("kolelce", "assets/kolelce.png", 512, 70);
        this.load.spritesheet("backBtn", "assets/backButtonsForScene.png", 256, 128);
        this.load.spritesheet("backToMenuBtn", "assets/backToMenuButt.png", 100, 100);
        this.load.spritesheet("helpBtn", "assets/helpSprite.png", 100, 100);
        this.load.spritesheet("soundBtn", "assets/soundBtn.png", 100, 100);
        this.load.spritesheet("tikcheta", "assets/tikcheta.png", 32, 32);
        this.load.spritesheet("closeBtn", "assets/closeBtn.png", 32, 32);
        this.load.spritesheet("textWalkBtn", "assets/textWalkBtn.png", 311, 98);
        this.load.spritesheet("videoWalkBtn", "assets/videoWalkBtn.png", 311, 98);
        this.load.image("emptyItem", "assets/emptyItem.png");
        this.load.image("selector", "assets/selector.png");
        this.load.image("messbox", "assets/messbox.png");
        this.load.image("helpBox", "assets/helpBox.png");
        this.load.spritesheet("fbBtn", "assets/fbBtn.png", 122, 61);

    },
    create: function () {
        resetHintTimer(false);

        //background and start Button
        this.backGroundRoom = this.add.sprite(0, 0, "backgroundMainMenu");
        //adds the ochichki
        this.addOchicki();

        //adds rate Btn
        this.btnCredits = this.add.button(384, 540, "btnCredits", function (e) {
            e.visible = false;
            this.startBtn.visible = false;
            this.credits.visible = true;
            this.backMenuBtn.visible = true;
        }, this, 0, 0, 1);
        this.startBtn = this.add.button(384, 400, "startBtn", function (e) {
            e.visible = false;
            this.btnCredits.visible = false;
            var sound = MUSICMANAGER["laugh_" + getRandomIntInclusive(1, 3)];
            if (sound) {
                sound.play();
            }

            this.levelBtns.showLevels();
            this.backMenuBtn.visible = true;
        }, this, 0, 0, 1);

        this.backMenuBtn = this.add.button(680, 650, "backMenuBtn", function (e) {
            e.visible = false;
            this.startBtn.visible = true;
            this.btnCredits.visible = true;
            if (!this.credits.visible) {
                this.levelBtns.hideLevels();
            }
            else {
                this.credits.visible = false;
            }
        }, this, 0, 0, 1);
        this.backMenuBtn.visible = false;

        this.exitBtn = this.add.button(830, 685, "exitBtn", function (e) {
            function onConfirm(buttonPressed) {
                GAMEMODE.rate = !GAMEMODE.rate;
                if (buttonPressed === 2) {
                    quitGame();
                    navigator.app.exitApp();
                }
            }
            function onRate(buttonPressed) {
                GAMEMODE.rate = !GAMEMODE.rate;
                if (buttonPressed === 1)
                    window.open(GAMEMODE.rateLink, '_system');
                else if (buttonPressed === 2) {
                    quitGame();
                    navigator.app.exitApp();
                }
            }

            if (!GAMEMODE.rate) {
                navigator.notification.confirm(
                    "Are you sure you want to exit?", // message
                    onConfirm, // callback to invoke with index of button pressed
                    "Exit", // title
                    ["No", "Yes"] // buttonLabels
                    );
            }
            else {
                navigator.notification.confirm(
                    "Help rate us on Google play if you like this app?", // message
                    onRate, // callback to invoke with index of button pressed
                    "Help us", // title
                    ["Rate Now", "Exit Anyway"] // buttonLabels
                    );
            }
        }, this, 0, 0, 1);

        this.credits = this.add.sprite(253, 375, "credits");
        this.credits.visible = false;

        this.levelBtns = {
            levels: [],
            setUp: function () {
                var startX = 314; //razlika 137
                var startY = 400;
                for (var i = 0; i < 5; i++) {
                    this.levels.push(GAMEMODE.pointerToLevel.add.button(startX, startY, "lv" + (i + 1) + "Btn", function (e) {
                        GAMEMODE.pointerToLevel.state.start(e.id);
                    }, GAMEMODE.pointerToLevel, 0, 0, 1));
                    startX += 137;
                    this.levels[i].id = "Level" + (i + 1);
                    this.levels[i].opened = false;
                    this.levels[i].visible = false;
                    if ((i + 1) % 3 === 0) {
                        startX = 314;
                        startY += 137;
                    }
                }
            },
            showLevels: function () {
                for (var i = 0; i < GAMEMODE.openedLevels; i++)
                    this.levels[i].visible = true;
            },
            hideLevels: function () {
                for (var i = 0; i < GAMEMODE.openedLevels; i++)
                    this.levels[i].visible = false;
            }
        }

        this.levelBtns.setUp();
    },
    update: function () {

    },
    createFrameOrder: function () {
        var frameOrder = [];
        for (var i = 0; i < 16; i++) {
            frameOrder.push(i);
        }

        frameOrder.push.apply(frameOrder, [14, 13, 12, 11, 10, 9, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0])

        return frameOrder;
    },
    addOchicki: function () {
        var frames = this.createFrameOrder();
        this.ochickiL = this.add.sprite(399, 173, "ochki_levi");
        this.ochickiL.animations.add("move", frames, 10, true);
        this.ochickiL.animations.play("move");

        this.ochickiD = this.add.sprite(505, 183, "ochki_desni");
        this.ochickiD.animations.add("move", frames, 10, true);
        this.ochickiD.animations.play("move");
    }

}